package yrpg.bamp.basedata.common;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.openapi.api.result.ApiSaveItemData;
import kd.bos.openapi.api.result.ApiSaveResult;
import kd.bos.openapi.api.result.BaseFilterItemData;
import kd.bos.openapi.api.result.BaseFilterResult;
import kd.bos.openapi.api.result.ApiSaveRowErrorData;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

public class AssembleResponseUtil {

    //将ApiSaveResult类型返回值组装进BaseFilterResult类型
    public static void assembleResult(ApiSaveResult data, BaseFilterResult responseData, boolean responseNotnull)  {
        List<ApiSaveItemData> result = data.getResult();
        for(ApiSaveItemData item:result){
            BaseFilterItemData baseFilterItemData = new BaseFilterItemData();
            baseFilterItemData.setNumber(item.getNumber());
            //报错时重新设置编码
            baseFilterItemData.setNumber(item.getKeys().get("yrpg_mainid"));
            baseFilterItemData.setId(item.getId());
            //组装错误信息
            List<ApiSaveRowErrorData> errors = item.getErrors();
            List<String> curerrors = new ArrayList<String>();
            for(ApiSaveRowErrorData errer:errors){
                //明细错误拼接
                StringBuffer sb = new StringBuffer();
                Set<String> rowMsg = errer.getRowMsg();
                for(String err:rowMsg){
                    sb = sb.append(err);
                }
                curerrors.add(sb.toString());
            }
            baseFilterItemData.setErrors(curerrors);
            //根据错误信息判断状态
            if(errors.size()>0){
                baseFilterItemData.setBillStatus(false);
            }else{
                baseFilterItemData.setBillStatus(true);
            }
            responseData.getResult().add(baseFilterItemData);
        }
        //成功失败条数
        long failCount = data.getFailCount();
        long successCount = data.getSuccessCount();
        //重新设置合计数
        if(responseNotnull){
            responseData.setTotalCount(responseData.getTotalCount()+failCount+successCount);
            responseData.setSuccessCount(responseData.getSuccessCount()+successCount);
            responseData.setFailCount(responseData.getFailCount()+failCount);
        }else{
            responseData.setTotalCount(failCount+successCount);
            responseData.setSuccessCount(successCount);
            responseData.setFailCount(failCount);
        }
    }

    public static void addfreezeResult(JSONArray newfreezeData, BaseFilterResult responseData,boolean flag)  {
        //将新增封存数据拼入返回值

        for(int i=0;i<newfreezeData.size();i++){
            JSONObject item = newfreezeData.getJSONObject(i);
            BaseFilterItemData baseFilterItemData = new BaseFilterItemData();
            baseFilterItemData.setNumber(item.getString("yrpg_mainid"));
            baseFilterItemData.setBillStatus(flag);
            if(!flag){
                List<String> curerrors = new ArrayList<String>();
                curerrors.add("核算组织编码不存在");
                baseFilterItemData.setErrors(curerrors);
                baseFilterItemData.setNumber(item.getString("yrpg_mainid"));
            }
            responseData.getResult().add(baseFilterItemData);
        }
        responseData.setTotalCount(responseData.getTotalCount()+newfreezeData.size());
        if(flag){
            responseData.setSuccessCount(responseData.getSuccessCount()+newfreezeData.size());
        }else{
            responseData.setFailCount(responseData.getFailCount()+newfreezeData.size());
        }

    }
}
